
create table AgenciaW
(
    CodigoEmp       char(2)         not null,
    CodigoBanco     char(3)         not null,
    Codigo          char(10)        not null,
    Nome            char(30)        not null,
    Gerente         char(30)        not null,
    Telefone        char(11)        not null,
    Ramal           char(4)         not null,
    Celular         char(11)        not null,
    RamalC          char(4)         not null,
    Fax             char(11)        not null,
    RamalFax        char(4)         not null,
    ContaAgencia    char(12)        not null    
);
  
Insert into AgenciaW select CodigoEmp, CodigoBanco, Codigo, Nome, Gerente,
                            Telefone+' ', Ramal, '00000000000', '0000', Fax+' ', RamalFax, ContaAgencia from Agencia;

alter table Conta drop FK_CONTA_AGECTA_AGENCIA;
 
alter table Agencia drop constraint FK_AGENCIA_BANAGE_BANCO;

alter table Agencia drop constraint pk_Agencia;

drop table Agencia; 
 
create table Agencia
(
    CodigoEmp       char(2)         not null,
    CodigoBanco     char(3)         not null,
    Codigo          char(10)        not null,
    Nome            char(30)        not null,
    Gerente         char(30)        not null,
    Telefone        char(11)        not null,
    Ramal           char(4)         not null,
    Celular         char(11)        not null,
    RamalC          char(4)         not null,
    Fax             char(11)        not null,
    RamalFax        char(4)         not null,
    ContaAgencia    char(12)        not null    
);
 
Insert into Agencia select * from AgenciaW;
 
alter table Agencia
    add constraint pk_Agencia primary key (CodigoEmp, CodigoBanco, Codigo);

alter table Agencia
    add constraint FK_AGENCIA_BANAGE_BANCO foreign key  (CodigoEmp, CodigoBanco)
       references Banco (CodigoEmp, Codigo);

alter table Conta
    add constraint FK_CONTA_AGECTA_AGENCIA foreign key  (CodigoEmp, CodigoBanco, CodigoAgencia)
       references Agencia (CodigoEmp, CodigoBanco, Codigo);

create index Agencia_FK1 on Agencia (CodigoEmp, CodigoBanco, Codigo, ContaAgencia);
 
GRANT ALL ON Agencia TO BYTEC;
  
Drop Table AgenciaW;
